Imports System
Imports System.IO

Public Class Form1
    Dim mApp As SolidEdgeFramework.Application
    Dim mPart As SolidEdgeFramework.SolidEdgeDocument
    Dim mSum As SolidEdgeFramework.SummaryInfo
    Dim objProps As SolidEdgeFramework.PropertySets
    Dim objProp As Object
    Dim objItem As Object
    Dim objFoldedDoc As Object
    Dim Vor, ergebnis, komAlt, nach As String
    Dim mf As Boolean
    Dim Materialstrke As Double

    Sub ausleser(ByVal vor As String, ByVal mf As Boolean)

        Dim Lnge, Breite, Dicke, Abwicklung_x, Abwicklung_y As Double
        Dim Kommentar As String
        Dim ok_x, ok_y As Boolean

        conected()
        komAlt = mSum.Comments

        'alle Benutzerdefinierte Variablen verden durchsucht und verglichen
        For Each objItem In objProp
            Select Case objItem.name
                Case "Lnge"
                    Lnge = objItem.value
                    Lnge = Math.Round(Lnge, 1)
                Case "Breite"
                    Breite = objItem.value
                    Breite = Math.Round(Breite, 1)
                Case "Dicke"
                    Dicke = objItem.value
                    Dicke = Math.Round(Dicke, 1)
                Case "Abwicklung_x_Schnittgre"
                    Abwicklung_x = objItem.value
                    Abwicklung_x = Math.Round(Abwicklung_x, 1)
                    ok_x = True
                Case "Abwicklung_y_Schnittgre"
                    Abwicklung_y = objItem.value
                    Abwicklung_y = Math.Round(Abwicklung_y, 1)
                    ok_y = True
            End Select
        Next
        If ok_x = False Or ok_y = False Then
            MsgBox("Es besteht keine gltige Abwicklung!", MsgBoxStyle.Critical)
            Me.Close()
        End If


        If mf = True Then abfrage()

        'Bei Flach oder 4-kt.Rohr wird zuerst die grssere Zahl dann die kleinere angezeigt.
        Select Case vor
            Case "Flach ", "Rohr  "
                Kommentar = vor & Breite & " x " & Dicke & " x " & Lnge & ergebnis
            Case "4-kt.Rohr "
                Kommentar = vor & Breite & "/" & Dicke & "/" & Materialstrke & " x " & Lnge & ergebnis

            Case "Rund  "
                Kommentar = vor & Breite & " x " & Lnge & ergebnis
            Case Else
                If Breite < Lnge Then
                    Kommentar = vor & Dicke & "x " & Breite & "x" & Lnge & ergebnis
                Else
                    Kommentar = vor & Dicke & "x " & Lnge & "x" & Breite & ergebnis
                End If
        End Select
        TextBox1.Text = Kommentar
        TextBox2.Text = komAlt
        mSum.Comments = Kommentar
    End Sub

    Private Sub Button1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Button2.Visible = True
        TextBox1.Text = TextBox2.Text
        Button3.Visible = False
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        conected()
        TextBox2.Text = mSum.Comments
        mSum.Comments = TextBox1.Text
        Button2.Visible = False
        Button3.Visible = True
    End Sub

    Sub conected()
        'Dim Kommentar, komAlt, ergebnis As String
        mApp = GetObject(, "solidedge.Application")
        mPart = mApp.ActiveDocument

        objProps = mPart.Properties
        objProp = objProps.Item("Custom")
        mSum = mPart.SummaryInfo
    End Sub

    Sub abfrage()

        Dim i As Integer
        For i = komAlt.Length - 1 To 0 Step -1
            If IsNumeric(komAlt.Substring(i, 1)) Then
                ergebnis = komAlt.Substring(i + 1)
                Exit For
            End If
        Next
        If ergebnis = " mit Folie" Or MitFolie.Checked = True Then
            MitFolie.Checked = True
            ergebnis = " mit Folie"
        End If
    End Sub
    Sub abfrage_materialstrke()

        'Hier wird die alte Materialstrke ermittelt und im Anzeigevorschlag eingeblendet
        komAlt = mSum.Comments
        If komAlt.Length < 1 Then Exit Sub
        Dim i, count, start, ende As Integer
        For i = 0 To komAlt.Length

            On Error Resume Next
            If komAlt.Substring(i, 1) = "/" Then
                count = count + 1
                If count = 2 Then
                    start = i + 1
                End If
            End If
            If komAlt.Substring(i, 1) = " " And count = 2 Then
                ende = i - start
                Exit For
            End If
        Next
        komAlt = komAlt.Substring(start, ende)
        If IsNumeric(komAlt) Then
            MatBox.Text = komAlt
        End If

    End Sub
    Private Sub MitFolie_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MitFolie.CheckedChanged
        If MitFolie.Checked = True Then
            ergebnis = "mit Folie"
            mf = True
        Else
            ergebnis = ""
            mf = False
            'Exit Sub
        End If
        ausleser(Vor, mf)
    End Sub

    Private Sub Blech_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Blech.CheckedChanged
        Vor = "Blech "
        ausleser(Vor, True)
    End Sub
    Private Sub Blech_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Blech.Click
        Vor = "Blech "
        ausleser(Vor, True)
    End Sub
    Private Sub Flach_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Flach.CheckedChanged
        Vor = "Flach "
        Mat.Visible = False
        MatBox.Visible = False
        Mat_Button.Visible = False
        ausleser(Vor, mf)
    End Sub

    Private Sub Rund_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Rund.CheckedChanged
        Vor = "Rund  "
        Mat.Visible = False
        MatBox.Visible = False
        Mat_Button.Visible = False
        ausleser(Vor, mf)
    End Sub

    Private Sub Rohr_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Rohr.CheckedChanged
        Vor = "Rohr  "
        Mat.Visible = False
        MatBox.Visible = False
        Mat_Button.Visible = False
        ausleser(Vor, mf)
    End Sub

    Private Sub Vierkant_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Vierkant.CheckedChanged
        Vor = "4-kt.Rohr "
        Mat.Visible = True
        MatBox.Visible = True
        Mat_Button.Visible = True
        Button3.Visible = False
        abfrage_materialstrke()
    End Sub

    Private Sub Vierkant_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Vierkant.Click
        Vor = "4-kt.Rohr "
        Mat.Visible = True
        MatBox.Visible = True
        Mat_Button.Visible = True
        Button3.Visible = False
        abfrage_materialstrke()
    End Sub

    Private Sub Leer_v_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Leer_v.CheckedChanged
        Vor = ""
        ausleser(Vor, mf)
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        dxf()
        Me.Close()
    End Sub

    Private Sub Form1_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Activated
        conected()
        Select Case mApp.ActiveEnvironment
            Case "SheetMetal"
                Blech.Enabled = True
                Flach.Enabled = True
                Leer_v.Enabled = True
                Rund.Enabled = False
                Rohr.Enabled = False
                Vierkant.Enabled = False
            Case "Part"
                Blech.Enabled = False
                Flach.Enabled = True
                Leer_v.Enabled = True
                Rund.Enabled = True
                Rohr.Enabled = True
                Vierkant.Enabled = True
        End Select

        TextBox2.Text = mSum.Comments
    End Sub

    Private Sub Mat_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Mat_Button.Click
        Materialstrke = MatBox.Text
        ausleser(Vor, mf)
        Mat.Visible = False
        MatBox.Visible = False
        Mat_Button.Visible = False
        Button3.Visible = True

    End Sub

    Sub dxf()

        Dim Pfad, Laufwerk, Ordner, Datei As String

        Laufwerk = "\\leuand2\office\FinnPowerDXF\Industrie\"
        'mSum.Title
        Datei = mSum.DocumentNumber & ".dxf"
        Ordner = Mid(Datei, 1, 3) & "#\"
        Pfad = Laufwerk & Ordner

        If My.Computer.FileSystem.FileExists(Pfad & Datei) = True Then
            MsgBox("Es existiert eine DXF Datei. Haben Sie diese schon aktualisiert?", MsgBoxStyle.Exclamation, "DXF Datei")
        ElseIf (Datei.Length < 10) Then
            MsgBox("Zuerst eine gltige Nummer lsen und dann das *.dxf - File erstellen !!")


        End If
        MsgBox(My.User.Name, MsgBoxStyle.Critical, "User")

        'MsgBox(Pfad & Datei)


    End Sub
End Class
